// LeviathanDlg.h : header file
//

#if !defined(AFX_LEVIATHANDLG_H__14D9C7C3_F749_4916_B169_904D0B03395C__INCLUDED_)
#define AFX_LEVIATHANDLG_H__14D9C7C3_F749_4916_B169_904D0B03395C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WM_ERROR WM_USER+4
#define WM_THREADSTARTING WM_USER+1
#define WM_THREADREADY WM_USER+2
#define WM_THREADSHUTDOWN WM_USER+3
#define WM_THREADDONE WM_USER+5
#define WM_STATICADD WM_USER+6
#define WM_DYNAMICADD WM_USER+7

/////////////////////////////////////////////////////////////////////////////
// CLeviathanDlg dialog

class CLeviathanDlg : public CDialog
{
// Construction
public:
	CLeviathanDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CLeviathanDlg)
	enum { IDD = IDD_LEVIATHAN_DIALOG };
	CButton	m_Scan;
	CProgressCtrl	m_Bar;
	CTabCtrl	m_Tab;
	CListCtrl	m_NB;
	CButton	m_View;
	CListBox	m_Status;
	CEdit	m_Host;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLeviathanDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	afx_msg LRESULT OnStartup(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnError(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnReady(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnShutdown(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnDone(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnStaticAdd(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDynamicAdd(WPARAM wParam, LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CLeviathanDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnScan();
	afx_msg void OnFileExit();
	afx_msg void OnHelpAbout();
	afx_msg void OnFileViewreport();
	afx_msg void OnActionChoosereportfile();
	afx_msg void OnSqlaudit();
	afx_msg void OnActionRange();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LEVIATHANDLG_H__14D9C7C3_F749_4916_B169_904D0B03395C__INCLUDED_)
