//RPC Class
#include "stdafx.h"
#include "leviathan.h"
#include "LeviathanDlg.h"
#include "RpcMod.h"

extern char *repDir;

RPCModule::RPCModule (char *HostName , HWND Win)
{
	win = Win;
	strcpy((char *)Host,HostName);
	char pth[MAX_PATH];
	sprintf(pth,"%s\\RPC.html\0",repDir);
	if(!(HTMLFile = fopen(pth,"w")))
	{
	}
	fprintf(HTMLFile, "<html>\n<head>\n<title>Leviathan RPC Analysis</title>\n</head>\n");
	fprintf(HTMLFile, "<BODY topmargin=\"20px\" leftmargin=\"10px\">\n");
	fprintf(HTMLFile, "<CENTER><BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>RPC Portmapper Entries(epmap:135) Of %s</FONT></FONT></B></CENTER>\n",Host);
	fprintf(HTMLFile, "<P><FONT FACE=\"Arial\"><FONT SIZE=-1>\n");
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
}
RPCModule::~RPCModule ()
{
	fprintf(HTMLFile,"</BODY>\n</HTML>\n");
	fclose(HTMLFile);
}
int RPCModule::EnumRPC()
{
	RPC_IF_ID IfId;
    RPC_BINDING_HANDLE hEnumBind;
    UUID uuid;
	RPC_BINDING_HANDLE hRpc;
    RPC_EP_INQ_HANDLE hInq;
    RPC_STATUS rpcErr;
    unsigned char *pAnnot;
	unsigned char *Binding = NULL;
    int counter = 0;
	char *proto = "ncacn_ip_tcp";

	if((rpcErr = RpcStringBindingCompose (NULL,(unsigned char*) proto,\
						(unsigned char*)Host,NULL, NULL, &Binding))!= RPC_S_OK)
        return counter;
    if((rpcErr = RpcBindingFromStringBinding (Binding, &hRpc))!= RPC_S_OK)
	{
        RpcStringFree (&Binding);
        return counter;
    }
    if((rpcErr = RpcMgmtEpEltInqBegin (hRpc, RPC_C_EP_ALL_ELTS, NULL, 0,NULL, &hInq))!= RPC_S_OK)
	{
        RpcStringFree (&Binding);
        RpcBindingFree (&hRpc);
        return counter;
    }
    do
	{  
        if((rpcErr = RpcMgmtEpEltInqNext (hInq, &IfId, &hEnumBind, &uuid, &pAnnot))== RPC_S_OK)
		{
            unsigned char *str = NULL;
            unsigned char *princName = NULL;
            counter++;
            if (pAnnot) 
			{
                if(strlen((char *)pAnnot) < 1)
					strcpy((char*)pAnnot,"Uknown");
				fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Service Name : </B>%s\n</FONT></FONT>\n",pAnnot);
                RpcStringFree (&pAnnot);
            }
            if (UuidToString (&uuid, &str) == RPC_S_OK) 
			{
                fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>UUID: </B>%s\n</FONT></FONT>\n",str);
                RpcStringFree (&str);
            }
            if (RpcBindingToStringBinding (hEnumBind, &str) == RPC_S_OK) 
			{
                fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Listening Protocol/Port : </B>%s\n</FONT></FONT>\n",str);
                RpcStringFree (&str);
            }
		}
        fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>--------------------------------------------------------------------\n</FONT></FONT></B>\n");
	}while (rpcErr != RPC_X_NO_MORE_ENTRIES);
	RpcStringFree (&Binding);
    RpcBindingFree (&hRpc);
    return counter;
}